#include <stdio.h>
#include <math.h>

#define K 1.38e-16
#define H 6.626e-27
#define C 2.9979e+10

int i,num_steps;
double flux,comp_flux,temp,lambda,start_lambda,end_lambda,d_lambda;
FILE *ofp;

void main()
{
	printf("\n\nNormalized Blackbody Flux Calculation\n\nInput blackbody temperature (in K) now... \n\tWell? ");
	scanf("%lf",&temp);
	printf("\nEnter starting wavelength (in microns) for calculation\n\tWell? ");
	scanf("%lf",&start_lambda);
	printf("\nEnter ending wavelength (in microns)\n\tWell? ");
	scanf("%lf",&end_lambda); 
	start_lambda/=1.0e4;
	end_lambda/=1.0e4;
	printf("\nNumber of calculation intervals\n\tWell? ");
	scanf("%d",&num_steps);  	
	d_lambda=(end_lambda-start_lambda)/(double)(num_steps);
	printf("\nStep separation is %6.5f microns...",d_lambda*10000.0);
	lambda=start_lambda;
	/* compute flux at 1 micron for scaling */
	comp_flux=2.0*H*C*C/(pow(0.0001,5.0));
	comp_flux=comp_flux/(exp(H*C/(0.0001*K*temp))-1.0);
	/* open data file */
	ofp=fopen("blackbody.txt","w");
	printf("\n\nOpening 'blackbody.txt' for output... \nnow calculating...");
	fprintf(ofp,"(microns)\t(relative intensity)");
	/* loop until end wavelength is met. Scale intensities, write to file */
	for(i==0;i<=(num_steps-1);i++)
	{
		flux=2.0*H*C*C/(pow(lambda,5.0));
		flux/=(exp(H*C/(lambda*K*temp))-1.0);
		flux/=comp_flux;
		fprintf(ofp,"\n%6.2lf \t %6.3e",lambda*1.0e4,flux);
		lambda+=d_lambda;
	}
	if(fclose(ofp)==EOF);
	printf("\n\nDone!\nIntensities were scaled to 1.0 microns\n"); 
}
